;; futures creates n threads for each expression given (as an argument)
(defmacro futures
  [n & exprs]
  (vec (for [_ (range n)
             expr exprs]
         `(future ~expr))))

;; wait-futures will run futures and block until all the values are realized
(defmacro wait-futures
  [& args]
  `(doseq [f# (futures ~@args)]
     @f#))
